//Written for www.HomoFaciens.de
//Program demonstrates interaction of bar magnets.
//Copyright (C) 2010 Norbert Heinz
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free //Software Foundation version 3 of the License.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or //FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, see http://www.gnu.org/licenses/.

import java.awt.*;
import java.awt.event.*;
import java.awt.font.FontRenderContext;
import java.awt.geom.Rectangle2D;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;
import java.text.*;
import java.applet.*;
import java.util.Random;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;



public class magnets extends JApplet implements  ActionListener, ChangeListener {

    static String versionNumber="v1.2";

    ScenePainter painter;
    JSpinner magnetSizeSpinner, magnetStrengthSpinner, distanceSpinner, magnetNumberSpinner, exFieldStrengthSpinner, exFieldAngleSpinner, fixedMagnetSpinner, fixedMagnetAngleSpinner, temperatureSpinner;
    JButton calcButton, randomButton;
    JLabel magnetSizeLabel, magnetStrengthLabel, distanceLabel, magnetNumberLabel, exFieldStrengthLabel, exFieldAngleLabel, fixedMagnetLabel, fixedMagnetAngleLabel, temperatureLabel;
    JLabel magnetSizeUnitLabel, MagnetStrenthUnitLabel, distanceUnitLabel, exFieldStrengthUnitLabel, exFieldAngleUnitLabel, fixedMagnetAngleUnitLabel, temperatureUnitLabel;
    JLabel sourceLabel;
    JRadioButton squareButton, triangleButton;
    Timer timer;             //timer for simulation
    int timerPause=25;       //delay between two calculated frames in milliseconds
    static String language="initalValue";
    String givenParam="nothing yet";   //To applet passed arguments
    int MagnetSizeMin=1, MagnetSizeMax=20, DistanceMin=21, DistanceMax=100, MagnetStrengthMin=1, MagnetStrengthMax=100, MagnetNumberMin=2, MagnetNumberMax=100;
    double Pi=3.1415927;
    static String ApplicationTitle="Magnets";

    public void init() {
        UIManager.put("swing.boldMetal", Boolean.FALSE);

        try{
          givenParam = getParameter("LanguageSettings");
        }
        catch(NullPointerException npe){
          System.out.println("could not get parameter 'LanguageSettings'");
        }

        if(givenParam.compareTo("nothing yet")!=0) {
          if (givenParam.compareTo("German")==0)language="German";
          else language="English";
        }
    }

    public void start() {
      int i;
        initComponents();

        timer = new Timer(timerPause, new timerEvent());
    }

    public static void main(String[] args) {

        if(args.length>0){
          if (args[0].compareTo("German")==0)language="German";
          else language="English";
        }
        else{
          language="English";
        }

        if(language.compareTo("German")==0){
          ApplicationTitle="Magnete";
        }
        else{
          ApplicationTitle="Magnets";
        }

        JFrame f = new JFrame(ApplicationTitle);
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        JApplet ap = new magnets();
        ap.init();
        ap.start();
        f.getContentPane().add("Center", ap);
        f.pack();
        f.setVisible(true);

    }

    public void initComponents() {
        int i;
        JFormattedTextField ftf = null;
        GridBagConstraints c = new GridBagConstraints();
        Font font = new Font("Arial", Font.PLAIN, 12);

        getContentPane().setLayout(new BorderLayout());

        //create panels
        JPanel controlPanel = new JPanel();
        JPanel scenePanel = new JPanel();
        JPanel mainPane = new JPanel();

        //set panel properties
        controlPanel.setLayout(new GridBagLayout());
        mainPane.setLayout(new BoxLayout(mainPane, BoxLayout.PAGE_AXIS));
        mainPane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));

        //create buttons, labels etcetera
        if(language.compareTo("German")==0){

          calcButton = new JButton("Start");
          calcButton.setMnemonic(KeyEvent.VK_S);

          randomButton = new JButton("Neu verteilen");
          randomButton.setMnemonic(KeyEvent.VK_Z);

          magnetNumberLabel = new JLabel("Anzahl Magnete:");
          magnetSizeLabel = new JLabel("Größe:");
          magnetStrengthLabel = new JLabel("Magnetstärke:");
          distanceLabel = new JLabel("Abstand:");
          exFieldStrengthLabel = new JLabel("Externes Feld");
          exFieldAngleLabel = new JLabel("Winkel");
          fixedMagnetLabel = new JLabel("Fixierter Magnet");
          fixedMagnetAngleLabel = new JLabel("Winkel");
          temperatureLabel = new JLabel("Temperatur");
          squareButton = new JRadioButton("Quadrat");
          triangleButton = new JRadioButton("Dreieck");
          squareButton.setMnemonic(KeyEvent.VK_Q);
          triangleButton.setMnemonic(KeyEvent.VK_D);
        }
        else if(language.compareTo("XXX")==0){
          magnetSizeLabel = new JLabel("XXX:");
        }
        else{

          calcButton = new JButton("Start");
          calcButton.setMnemonic(KeyEvent.VK_S);

          randomButton = new JButton("Arrange new");
          randomButton.setMnemonic(KeyEvent.VK_R);

          magnetNumberLabel = new JLabel("Number of magnets:");
          magnetSizeLabel = new JLabel("Size:");
          magnetStrengthLabel = new JLabel("Strength:");
          distanceLabel = new JLabel("Distance:");
          exFieldStrengthLabel = new JLabel("External Field");
          exFieldAngleLabel = new JLabel("Angle");
          fixedMagnetLabel = new JLabel("Fixed magnet");
          fixedMagnetAngleLabel = new JLabel("Angle");
          temperatureLabel = new JLabel("Temperature");
          squareButton = new JRadioButton("Square");
          triangleButton = new JRadioButton("Triangle");
          squareButton.setMnemonic(KeyEvent.VK_Q);
          triangleButton.setMnemonic(KeyEvent.VK_T);
        }

        magnetSizeUnitLabel = new JLabel("%");
        MagnetStrenthUnitLabel = new JLabel("%");
        distanceUnitLabel = new JLabel("%");
        exFieldStrengthUnitLabel = new JLabel("%");
        exFieldAngleUnitLabel = new JLabel("Deg");
        fixedMagnetAngleUnitLabel = new JLabel("Deg");
        temperatureUnitLabel = new JLabel("%");
        sourceLabel = new JLabel(versionNumber + "   Source & info:    www.HomoFaciens.de");

        squareButton.setFont(font);
        squareButton.setActionCommand("squareButtonPressed");
        squareButton.setSelected(true);
        squareButton.addActionListener(this);

        triangleButton.setFont(font);
        triangleButton.setActionCommand("triangleButtonPressed");
        triangleButton.setSelected(false);
        triangleButton.addActionListener(this);

        ButtonGroup group = new ButtonGroup();
        group.add(squareButton);
        group.add(triangleButton);


        SpinnerNumberModel exFieldStrengthModel = new SpinnerNumberModel(0, 0, 100, 1);
        exFieldStrengthSpinner = new JSpinner(exFieldStrengthModel);
        ftf = getTextField(exFieldStrengthSpinner);
        if (ftf != null ) {
            ftf.setFont(font);
            ftf.setColumns(4); //specify more width than we need
            ftf.setHorizontalAlignment(JTextField.RIGHT);
        }
        exFieldStrengthSpinner.addChangeListener(this);

        SpinnerNumberModel exFieldAngleModel = new SpinnerNumberModel(0, 0, 360, 1);
        exFieldAngleSpinner = new JSpinner(exFieldAngleModel);
        ftf = getTextField(exFieldAngleSpinner);
        if (ftf != null ) {
            ftf.setFont(font);
            ftf.setColumns(4); //specify more width than we need
            ftf.setHorizontalAlignment(JTextField.RIGHT);
        }
        exFieldAngleSpinner.addChangeListener(this);

        SpinnerNumberModel fixedMagnetModel = new SpinnerNumberModel(0, 0, 500, 1);
        fixedMagnetSpinner = new JSpinner(fixedMagnetModel);
        ftf = getTextField(fixedMagnetSpinner);
        if (ftf != null ) {
            ftf.setFont(font);
            ftf.setColumns(4); //specify more width than we need
            ftf.setHorizontalAlignment(JTextField.RIGHT);
        }
        fixedMagnetSpinner.addChangeListener(this);

        SpinnerNumberModel fixedMagnetAngleModel = new SpinnerNumberModel(0, 0, 360, 1);
        fixedMagnetAngleSpinner = new JSpinner(fixedMagnetAngleModel);
        ftf = getTextField(fixedMagnetAngleSpinner);
        if (ftf != null ) {
            ftf.setFont(font);
            ftf.setColumns(4); //specify more width than we need
            ftf.setHorizontalAlignment(JTextField.RIGHT);
        }
        fixedMagnetAngleSpinner.addChangeListener(this);

        SpinnerNumberModel magnetNumberModel = new SpinnerNumberModel(105, 2, 500, 1);
        magnetNumberSpinner = new JSpinner(magnetNumberModel);
        ftf = getTextField(magnetNumberSpinner);
        if (ftf != null ) {
            ftf.setFont(font);
            ftf.setColumns(4); //specify more width than we need
            ftf.setHorizontalAlignment(JTextField.RIGHT);
        }
        magnetNumberSpinner.addChangeListener(this);

        SpinnerNumberModel magnetSizeModel = new SpinnerNumberModel(35, 10, 100, 1);
        magnetSizeSpinner = new JSpinner(magnetSizeModel);
        ftf = getTextField(magnetSizeSpinner);
        if (ftf != null ) {
            ftf.setFont(font);
            ftf.setColumns(4); //specify more width than we need
            ftf.setHorizontalAlignment(JTextField.RIGHT);
        }
        magnetSizeSpinner.addChangeListener(this);
        magnetSizeLabel.setLabelFor(magnetSizeSpinner);

        SpinnerNumberModel magnetStrengthModel = new SpinnerNumberModel(50, 1, 100, 1);
        magnetStrengthSpinner = new JSpinner(magnetStrengthModel);
        ftf = getTextField(magnetStrengthSpinner);
        if (ftf != null ) {
            ftf.setFont(font);
            ftf.setColumns(4); //specify more width than we need
            ftf.setHorizontalAlignment(JTextField.RIGHT);
        }
        magnetStrengthSpinner.addChangeListener(this);

        SpinnerNumberModel distanceModel = new SpinnerNumberModel(20, 20, 100, 1);
        distanceSpinner = new JSpinner(distanceModel);
        ftf = getTextField(distanceSpinner);
        if (ftf != null ) {
            ftf.setFont(font);
            ftf.setColumns(4); //specify more width than we need
            ftf.setHorizontalAlignment(JTextField.RIGHT);
        }
        distanceSpinner.addChangeListener(this);

        SpinnerNumberModel temperatureModel = new SpinnerNumberModel(0, 0, 100, 1);
        temperatureSpinner = new JSpinner(temperatureModel);
        ftf = getTextField(temperatureSpinner);
        if (ftf != null ) {
            ftf.setFont(font);
            ftf.setColumns(4); //specify more width than we need
            ftf.setHorizontalAlignment(JTextField.RIGHT);
        }
        temperatureSpinner.addChangeListener(this);


        painter = new ScenePainter();

        //set properties of controls
        magnetSizeUnitLabel.setFont(font);
        MagnetStrenthUnitLabel.setFont(font);
        distanceUnitLabel.setFont(font);

        magnetNumberLabel.setFont(font);
        magnetSizeLabel.setFont(font);
        magnetStrengthLabel.setFont(font);
        distanceLabel.setFont(font);

        sourceLabel.setFont(font);

        calcButton.setFont(font);
        calcButton.setActionCommand("calcButtonPressed");
        calcButton.addActionListener(this);

        randomButton.setFont(font);
        randomButton.setActionCommand("randomButtonPressed");
        randomButton.addActionListener(this);

        //add components
        c.fill = GridBagConstraints.HORIZONTAL;
        c.ipadx = 10;
        c.insets = new Insets(5,5,5,5);  //padding


        c.fill = GridBagConstraints.HORIZONTAL;
        c.anchor=GridBagConstraints.CENTER;
        c.gridx = 0;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(magnetSizeLabel, c);

        c.gridx = 1;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(magnetSizeSpinner, c);

        c.gridx = 2;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(magnetSizeUnitLabel, c);

        c.gridx = 3;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(magnetStrengthLabel, c);

        c.gridx = 4;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(magnetStrengthSpinner, c);

        c.gridx = 5;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(MagnetStrenthUnitLabel, c);

        c.gridx = 6;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(distanceLabel, c);

        c.gridx = 7;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(distanceSpinner, c);

        c.gridx = 8;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(distanceUnitLabel, c);

        c.gridx = 9;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(magnetNumberLabel, c);

        c.gridx = 10;
        c.gridy = 0;
        c.gridwidth=1;
        controlPanel.add(magnetNumberSpinner, c);

        c.gridx = 11;
        c.gridy = 0;
        c.gridwidth=1;
        //controlPanel.add(magnetNumberUnitLabel, c);

        c.gridx = 0;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(exFieldStrengthLabel, c);

        c.gridx = 1;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(exFieldStrengthSpinner, c);

        c.gridx = 2;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(exFieldStrengthUnitLabel, c);

        c.gridx = 3;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(exFieldAngleLabel, c);

        c.gridx = 4;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(exFieldAngleSpinner, c);

        c.gridx = 5;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(exFieldAngleUnitLabel, c);

        c.gridx = 6;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(fixedMagnetLabel, c);

        c.gridx = 7;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(fixedMagnetSpinner, c);

        c.gridx = 8;
        c.gridy = 1;
        c.gridwidth=1;
        //controlPanel.add(exFieldAngleUnitLabel, c);

        c.gridx = 9;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(fixedMagnetAngleLabel, c);

        c.gridx = 10;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(fixedMagnetAngleSpinner, c);

        c.gridx = 11;
        c.gridy = 1;
        c.gridwidth=1;
        controlPanel.add(fixedMagnetAngleUnitLabel, c);

        c.gridx = 0;
        c.gridy = 2;
        c.gridwidth=1;
        controlPanel.add(temperatureLabel, c);

        c.gridx = 1;
        c.gridy = 2;
        c.gridwidth=1;
        controlPanel.add(temperatureSpinner, c);

        c.gridx = 2;
        c.gridy = 2;
        c.gridwidth=1;
        controlPanel.add(temperatureUnitLabel, c);

        c.gridx = 6;
        c.gridy = 2;
        c.gridwidth=3;
        controlPanel.add(squareButton, c);

        c.gridx = 9;
        c.gridy = 2;
        c.gridwidth=3;
        controlPanel.add(triangleButton, c);

        c.gridx = 0;
        c.gridy = 3;
        c.gridwidth=3;
        controlPanel.add(randomButton, c);
        c.gridx = 3;
        c.gridy = 3;
        c.gridwidth=3;
        controlPanel.add(calcButton, c);

        c.gridx = 6;
        c.gridy = 3;
        c.gridwidth=5;
        c.fill = GridBagConstraints.NONE;
        c.anchor=GridBagConstraints.LINE_END;
        controlPanel.add(sourceLabel, c);


        //setup panels
        scenePanel.add("Center", painter);

        mainPane.add(scenePanel);
        mainPane.add(controlPanel);
        getContentPane().add(mainPane);
        getRootPane().setDefaultButton(calcButton);


        //initialize magnets
        double RowX, RowY, Spacer;

        painter.MagnetSize=((Integer)magnetSizeSpinner.getValue()).doubleValue() / 2.0;
        painter.MagnetDistance=((Integer)distanceSpinner.getValue()).doubleValue() / 2.0;
        painter.MagnetsCount=(int)((Integer)magnetNumberSpinner.getValue()).doubleValue();
        painter.MagnetStrength=(int)((Integer)magnetStrengthSpinner.getValue()).doubleValue();
        painter.fixedMagnetNo=(int)((Integer)fixedMagnetSpinner.getValue()).doubleValue() - 1;
        painter.exFieldStrength=(int)((Integer)exFieldStrengthSpinner.getValue()).doubleValue();
        painter.exFieldAngle=(int)((Integer)exFieldAngleSpinner.getValue()).doubleValue() * Pi / 180.0;
        painter.MagnetVibration=(int)((Integer)temperatureSpinner.getValue()).doubleValue();

        Random RandomGenerator = new Random();
        for(i=0;i<painter.MagnetsCount;i++){
          painter.MagnetCoords[i][2]=(double)RandomGenerator.nextInt(2 * 31415927) / 10000000.0;//Set random angle of magnets
        }

        initMagnets();

    }

    public JFormattedTextField getTextField(JSpinner spinner) {
        JComponent editor = spinner.getEditor();
        if (editor instanceof JSpinner.DefaultEditor) {
            return ((JSpinner.DefaultEditor)editor).getTextField();
        } else {
            System.err.println("Unexpected editor type: "  + spinner.getEditor().getClass() + " isn't a descendant of DefaultEditor");
            return null;
        }
    }

    public void initMagnets(){
      double RowX, RowY, Spacer;
      boolean halfSpace=false;
      int i, i2;

      painter.MagnetSize=((Integer)magnetSizeSpinner.getValue()).doubleValue() / 2.0;
      painter.MagnetDistance=((Integer)distanceSpinner.getValue()).doubleValue() / 2.0;
      painter.MagnetsCount=(int)((Integer)magnetNumberSpinner.getValue()).doubleValue();
      painter.MagnetStrength=(int)((Integer)magnetStrengthSpinner.getValue()).doubleValue();
      painter.fixedMagnetNo=(int)((Integer)fixedMagnetSpinner.getValue()).doubleValue() - 1;
      painter.exFieldStrength=(int)((Integer)exFieldStrengthSpinner.getValue()).doubleValue();
      painter.exFieldAngle=(int)((Integer)exFieldAngleSpinner.getValue()).doubleValue() * Pi / 180.0;
      painter.MagnetVibration=(int)((Integer)temperatureSpinner.getValue()).doubleValue();

      if(painter.fixedMagnetNo>-1){
        painter.MagnetCoords[painter.fixedMagnetNo][2]=((Integer)fixedMagnetAngleSpinner.getValue()).doubleValue() * Pi / 180.0;
      }

      Spacer=(painter.MagnetSize + painter.MagnetDistance) * 2.0;
      RowY=Spacer/2.0;
      RowX=Spacer/2.0;
      if (painter.MagnetsCount*Spacer<painter.sceneWidth){
        RowY=painter.sceneHeight/2;
        RowX=(painter.sceneWidth-painter.MagnetsCount*Spacer)/2;
      }
      if(painter.GridStyle==1){
        for(i=0;i<painter.MagnetsCount;i++){
          painter.MagnetCoords[i][0]=RowX;
          painter.MagnetCoords[i][1]=RowY;
          RowX+=Spacer;
          if(RowX>painter.sceneWidth - Spacer){
            if(halfSpace){
              RowX=Spacer/2.0;
              halfSpace=false;
            }
            else{
              RowX=Spacer;
              halfSpace=true;
            }
            RowY+=Math.sqrt(Math.pow(Spacer, 2.0) - Math.pow(Spacer, 2.0)/2.0);
          }
          painter.MagnetCoords[i][3]=0.0;
        }
      }
      else{
        for(i=0;i<painter.MagnetsCount;i++){
          painter.MagnetCoords[i][0]=RowX;
          painter.MagnetCoords[i][1]=RowY;
          RowX+=Spacer;
          if(RowX>painter.sceneWidth - Spacer){
            RowX=Spacer/2.0;
            RowY+=Spacer;
          }
          painter.MagnetCoords[i][3]=0.0;
        }
      }
   }

    public void stateChanged(ChangeEvent e) {
      initMagnets();
      painter.refreshScene();
    }

    // Listens to the buttons.
    public void actionPerformed(ActionEvent e) {

        if("squareButtonPressed".equals(e.getActionCommand())) {
          painter.GridStyle=0;
          initMagnets();
          painter.refreshScene();
        }
        if("triangleButtonPressed".equals(e.getActionCommand())) {
          painter.GridStyle=1;
          initMagnets();
          painter.refreshScene();
        }
        if("randomButtonPressed".equals(e.getActionCommand())) {
          int i, i2;
          Random RandomGenerator = new Random();
          for(i=0;i<painter.MagnetsCount;i++){
            if(i!=painter.fixedMagnetNo){
              painter.MagnetCoords[i][2]=(double)RandomGenerator.nextInt(2 * 31415927) / 10000000.0;//Set random angle of magnets
            }
          }
          painter.refreshScene();
        }
        if("calcButtonPressed".equals(e.getActionCommand())) {

          if(painter.isRunning){
            painter.isRunning=false;
          }
          else{
            if(language.compareTo("German")==0){
              calcButton.setText("Stopp");
            }
            else if(language.compareTo("XXX")==0){
              calcButton.setText("Stop");
            }
            else{
              calcButton.setText("Stop");
            }
            if(timer.getInitialDelay()!=timerPause){
              timer.setInitialDelay(timerPause);
            }
            timer.start();
            painter.isRunning=true;
          }//if(!isRunning)
        }//if ("calcButtonPressed".equals(e.getActionCommand())) {
    }

    private class timerEvent implements ActionListener{
      public void actionPerformed(ActionEvent e){

        if(!painter.isRunning){
          timer.stop();
          if(language.compareTo("German")==0){
            calcButton.setText("Start");
          }
          else if(language.compareTo("XXX")==0){
            calcButton.setText("Start");
          }
          else{
            calcButton.setText("Start");
          }
        }

        painter.MagnetStrength=(int)((Integer)magnetStrengthSpinner.getValue()).doubleValue();
        painter.fixedMagnetNo=(int)((Integer)fixedMagnetSpinner.getValue()).doubleValue() - 1;
        if(painter.fixedMagnetNo>-1){
          painter.MagnetCoords[painter.fixedMagnetNo][2]=(int)((Integer)fixedMagnetAngleSpinner.getValue()).doubleValue() * Pi / 180.0;
        }
        painter.exFieldStrength=(int)((Integer)exFieldStrengthSpinner.getValue()).doubleValue();
        painter.exFieldAngle=(int)((Integer)exFieldAngleSpinner.getValue()).doubleValue() * Pi / 180.0;

        painter.refreshScene();
      }
    }
}



class ScenePainter extends Component {

    int sceneHeight = 400, sceneWidth = 900;
    double[][] MagnetCoords = new double[500][4];
    double MagnetSize=20.0;
    double MagnetDistance=20.0;
    double MagnetStrength=20.0;
    double MagnetVibration=0.0;
    int MagnetsCount=40;
    int fixedMagnetNo=1;
    double exFieldStrength=9.9, exFieldAngle=0;
    BufferedImage bufferImage=null;
    Graphics2D bufferImageSurface=null;
    boolean isRunning=false;
    int GridStyle=0;

    public Dimension getPreferredSize(){
        return new Dimension(sceneWidth, sceneHeight);
    }

    void refreshScene() {
      repaint();
    }

    public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        Dimension size = getSize();
        Composite origComposite;
        int i, i2, i3;
        double Pi=3.1415927;
        double SouthX, SouthY, NorthX, NorthY, SouthX2, SouthY2, NorthX2, NorthY2;
        double SouthAngle, NorthAngle, SouthNorthAngle, NorthSouthAngle;
        double TorqueSouth, TorqueNorth, TorqueSouthNorth, TorqueNorthSouth, TorqueExField;
        double SPoleDistance, NPoleDistance, SNPoleDistance, NSPoleDistance;

        //create buffer to avoid flickering while scene is calculated and painted
        if(bufferImage==null){
          bufferImage = (BufferedImage)createImage(sceneWidth, sceneHeight);
          bufferImageSurface = bufferImage.createGraphics();
        }

        origComposite = g2.getComposite();

        bufferImageSurface.setBackground(new Color(255, 255, 255));
        bufferImageSurface.clearRect(0, 0, sceneWidth, sceneHeight);

        //Paint grey lines if external field is on
        if(exFieldStrength>0){
          bufferImageSurface.setColor(new Color(200, 200, 200));
          int LineSpace, LineLength;
          int xPos=0, yPos=0;
          double LineAngle;

          LineAngle=exFieldAngle;
          LineAngle=2.0*Pi-LineAngle;
          if(LineAngle>Pi)LineAngle-=Pi;
          LineLength=(int)(Math.sqrt(Math.pow(sceneWidth, 2.0) + Math.pow(sceneHeight, 2.0)));
          LineSpace=(int)((double)LineLength / (20.0 + exFieldStrength));

          if(LineAngle == 0.0 || LineAngle == Pi){
            while(yPos<sceneHeight){
              bufferImageSurface.drawLine(0, yPos, sceneWidth, yPos);
              yPos+=(int)LineSpace;
            }
          }
          if(LineAngle > 0 && LineAngle < Pi * 0.5){
            xPos=0;
            yPos=0;
            while(xPos<sceneWidth){
              bufferImageSurface.drawLine(xPos, 0, xPos + (int)((double)LineLength * Math.cos(LineAngle)), (int)((double)LineLength * Math.sin(LineAngle)));
              xPos+=(int)((double)LineSpace / Math.sin(LineAngle));
            }
            while(yPos<sceneHeight){
              bufferImageSurface.drawLine(0, yPos, (int)((double)LineLength * Math.cos(LineAngle)), yPos + (int)((double)LineLength * Math.sin(LineAngle)));
              yPos+=(int)((double)LineSpace / Math.cos(LineAngle));
            }
          }
          if(LineAngle == Pi * 0.5){
            xPos=0;
            while(xPos < sceneWidth){
              bufferImageSurface.drawLine(xPos, 0, xPos, sceneHeight);
              xPos+=(int)LineSpace;
            }
          }
          if(LineAngle > Pi * 0.5 && LineAngle < Pi){
            xPos=0;
            yPos=0;
            xPos=sceneWidth;
            while(xPos>0){
              bufferImageSurface.drawLine(xPos, 0, xPos + (int)((double)LineLength * Math.cos(LineAngle)), (int)((double)LineLength * Math.sin(LineAngle)));
              xPos-=(int)((double)LineSpace / Math.sin(LineAngle));
            }
            while(yPos<sceneHeight){
              bufferImageSurface.drawLine(sceneWidth, yPos, sceneWidth + (int)((double)LineLength * Math.cos(LineAngle)), yPos + (int)((double)LineLength * Math.sin(LineAngle)));
              yPos-=(int)((double)LineSpace / Math.cos(LineAngle));
            }
          }
        }//if(exFieldStrength>0){



        //Calculating angle of magnets
        //A very simple model is used to reduce computing power needed:
        //Magnetic monopoles are placed at the tips of the magnets and the resulting torque added over all magnets is calculated.
        //The force induced by the monopoles is similar to coulomb's law
        //The resulting torque is transformed to a accoording change of angle (higher torque results in a greater change of angle)

        if(isRunning){
          for(i=0;i<MagnetsCount;i++){

            TorqueSouth=0.0;
            TorqueNorth=0.0;
            TorqueSouthNorth=0.0;
            TorqueNorthSouth=0.0;
            TorqueExField=0.0;

            SouthX=MagnetCoords[i][0] + Math.cos(MagnetCoords[i][2])*MagnetSize;
            SouthY=MagnetCoords[i][1] + Math.sin(MagnetCoords[i][2])*MagnetSize;
            NorthX=MagnetCoords[i][0] - Math.cos(MagnetCoords[i][2])*MagnetSize;
            NorthY=MagnetCoords[i][1] - Math.sin(MagnetCoords[i][2])*MagnetSize;
            for(i2=0;i2<MagnetsCount;i2++){
              if(i2!=i && i!=fixedMagnetNo){
                SouthX2=MagnetCoords[i2][0] + Math.cos(MagnetCoords[i2][2])*MagnetSize;
                SouthY2=MagnetCoords[i2][1] + Math.sin(MagnetCoords[i2][2])*MagnetSize;
                NorthX2=MagnetCoords[i2][0] - Math.cos(MagnetCoords[i2][2])*MagnetSize;
                NorthY2=MagnetCoords[i2][1] - Math.sin(MagnetCoords[i2][2])*MagnetSize;

                SPoleDistance=Math.sqrt(Math.pow(SouthX2 - SouthX, 2.0) + Math.pow(SouthY2 - SouthY, 2.0));
                NPoleDistance=Math.sqrt(Math.pow(NorthX2 - NorthX, 2.0) + Math.pow(NorthY2 - NorthY, 2.0));
                SNPoleDistance=Math.sqrt(Math.pow(SouthX2 - NorthX, 2.0) + Math.pow(SouthY2 - NorthY, 2.0));
                NSPoleDistance=Math.sqrt(Math.pow(NorthX2 - SouthX, 2.0) + Math.pow(NorthY2 - SouthY, 2.0));

                SouthAngle=Pi - (Pi - MagnetCoords[i][2] + Math.atan2(SouthY2 - SouthY, SouthX2 - SouthX));
                NorthAngle=Pi - (Pi - MagnetCoords[i][2] + Pi + Math.atan2(NorthY2 - NorthY, NorthX2 - NorthX));
                SouthNorthAngle=Pi - (Pi - MagnetCoords[i][2] + Pi + Math.atan2(SouthY2 - NorthY, SouthX2 - NorthX));
                NorthSouthAngle=Pi - (Pi - MagnetCoords[i][2] + Math.atan2(NorthY2 - SouthY, NorthX2 - SouthX));

                TorqueSouth+=MagnetStrength / Math.pow(SPoleDistance, 2.0) * Math.sin(SouthAngle) * MagnetSize;
                TorqueNorth+=MagnetStrength / Math.pow(NPoleDistance, 2.0) * Math.sin(NorthAngle) * MagnetSize;
                TorqueSouthNorth-=MagnetStrength / Math.pow(SNPoleDistance, 2.0) * Math.sin(SouthNorthAngle) * MagnetSize;
                TorqueNorthSouth-=MagnetStrength / Math.pow(NSPoleDistance, 2.0) * Math.sin(NorthSouthAngle) * MagnetSize;
              }
            }
            if(i!=fixedMagnetNo){
              TorqueExField=Math.sin(exFieldAngle-MagnetCoords[i][2]) * exFieldStrength * MagnetStrength / 900;
            }
            MagnetCoords[i][3]=TorqueSouth + TorqueNorth + TorqueSouthNorth + TorqueNorthSouth + TorqueExField;
          }
        }//if(isRunning)

        //painting magnets
        Random RandomGenerator = new Random();
        double MagnetVibration2 = 0;
        for(i=0;i<MagnetsCount;i++){
          if(isRunning){
            //Magnet vibration simulates the influence of temperature
            MagnetVibration2=0.0;
            if(RandomGenerator.nextInt(1000)>300){
              MagnetVibration2=(double)(RandomGenerator.nextInt(3)-1) * Pi / 180.0 * MagnetVibration / 5.0;
            }
            //The multiplicator is used to reduce speed of rotation.
            //Higher values make the rotation become faster.
            //A too high value leads to needle-vibration, because too many intermediate steps of the movement are lost!
            MagnetCoords[i][2] += MagnetCoords[i][3] * 0.03 + MagnetVibration2;
          }

          bufferImageSurface.setColor(new Color(0,255,0));
          bufferImageSurface.drawLine((int) MagnetCoords[i][0],
                                      sceneHeight - (int) MagnetCoords[i][1],
                                      (int) MagnetCoords[i][0] + (int) (Math.cos(MagnetCoords[i][2])*MagnetSize),
                                      sceneHeight - ((int) MagnetCoords[i][1] + (int) (Math.sin(MagnetCoords[i][2])*MagnetSize)));
          bufferImageSurface.setColor(new Color(255,0,0));
          bufferImageSurface.drawLine((int) MagnetCoords[i][0],
                                      sceneHeight - (int) MagnetCoords[i][1],
                                      (int) MagnetCoords[i][0] - (int) (Math.cos(MagnetCoords[i][2])*MagnetSize),
                                      sceneHeight - ((int) MagnetCoords[i][1] - (int) (Math.sin(MagnetCoords[i][2])*MagnetSize)));
          if(i==fixedMagnetNo){//mark fixed magnet
            bufferImageSurface.setColor(new Color(0,0,0));
            bufferImageSurface.drawOval( (int) (MagnetCoords[i][0] - MagnetSize),
                                         sceneHeight - (int) (MagnetCoords[i][1] + MagnetSize),
                                         (int) MagnetSize * 2,
                                         (int) MagnetSize * 2 );
          }
        }


        bufferImageSurface.setColor(new Color(0,0,0));
        bufferImageSurface.drawRect(0, 0, sceneWidth-1, sceneHeight-1);

        //paint bufferImage and make it visible
        g2.drawImage(bufferImage, 0, 0, this);

        g2.setComposite(origComposite);

    }
}

